from datetime import datetime
from application.app import db
from models.{{ config['name'] }} import {{ config['name'] | letterUpper }}Model
from webcreator.log import logger
from webcreator.response import ResponseCode, response_result

class {{ config['name'] | letterUpper }}Resource(object):
    def __init__(self):
        super().__init__()

    def get(self, params):
        # handle business
        logger.warn(params)
        filters = []
        result = {{ config['name'] | letterUpper }}Model.query.filter(*filters).order_by({{ config['name'] | letterUpper }}Model.areaId).paginate(params.get('page', 1), params.get('pageSize', 10), error_out=False)

        return result

    def getList(self, params):
        # handle business
        logger.warn(params)
        filters = []
        result = {{ config['name'] | letterUpper }}Model.query.filter(*filters).order_by({{ config['name'] | letterUpper }}Model.areaId).paginate(params.get('page', 1), params.get('pageSize', 10), error_out=False)

        return result

    def post(self, params, jwt=None):
        # handle business
        result = {{ config['name'] | letterUpper }}Model.query.filter({{ config['name'] | letterUpper }}Model.{{ config["model"]["fields"][0]["name"] }} == params.get('{{ config["model"]["fields"][0]["name"] }}')).first()
        if result and result.is_delete:
            result.is_delete = False
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            db.session.commit()
            return response_result(ResponseCode.OK)
        elif result and result.is_delete == False:
            return response_result(ResponseCode.EXISTS_ERROR)

        result = {{ config['name'] | letterUpper }}Model(**params)
        db.session.add(result)
        db.session.commit()
        return response_result(ResponseCode.OK)

    def put(self, id, params, jwt=None):
        # handle business
        result = {{ config['name'] | letterUpper }}Model.query.get(id)
        if not result: return response_result(ResponseCode.NO_DATA)
        if params:
            for key, value in params.items():
                if value != None: setattr(result, key, value)
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            db.session.commit()
        else:
            return response_result(ResponseCode.PARAM_NULL)

    def delete(self, id, jwt=None):
        # handle business
        result = {{ config['name'] | letterUpper }}Model.query.get(id)
        if not result: return response_result(ResponseCode.NO_DATA_FOUND)
        else:
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            result.is_delete = True
            db.session.delete(result)
            db.session.commit()

{{ config["name"] }}Manager = {{ config['name'] | letterUpper }}Resource()